"""
 --------------------------------------------------------
		arcTUFLOW_Library - Arc TUFLOW functionality
        begin                : 2013-08-27
        copyright            : (C) 2013 by Phillip Ryan
        email                : support@tuflow.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""


def run_tuflow(tfexe,tcf):
	
	try:
		from subprocess import Popen
		tfarg = [tfexe, '-b',tcf]
		tf_proc = Popen(tfarg)
	except:
		return "Error occurred starting TUFLOW"

	return None

def config_set(config_file,tuflow_folder,tfexe,proj):
	import os
	message = None
	try:
		f = file(config_file, 'w')
		f.write('TUFLOW Folder =='+tuflow_folder+'\n')
		f.write('TUFLOW Exe =='+tfexe+'\n')
		f.write('PROJECTION =='+proj+'\n')
		f.flush()
		f.close()
	except:
		message = "Unable to write TUFLOW config file: "+config_file

	return message

def read_config(config_file):
	import os
	import numpy
	message = None
	config = None
	fpath = os.path.dirname(config_file)
	data = numpy.genfromtxt(config_file, dtype=None, delimiter="==")
	for i in range (0,len(data)):
		tmp = data[i,0]
		dat_type = tmp.strip()
		tmp = data[i,1]
		rdata = tmp.strip()
		if dat_type == "TUFLOW Folder":
			tuflow_folder = rdata
		elif dat_type == "TUFLOW Exe":
			tfexe = rdata
		elif dat_type == "TPROJECTION":
			proj = rdata
		else:
			message = "Unexpected line in config file. Line number: "+str(i+1)
	config = dict([('tuflow_folder',tuflow_folder), ('tfexe',tfexe), ('projection',proj)])
	return message, config
