#-------------------------------------------------------------------------------
# Name:        configure TUFLOW gdb
# Purpose:
#
# Author:      par
#
# Created:     21/04/2012
# Copyright:   (c) par 2012
# Licence:     <your licence>
#-------------------------------------------------------------------------------

import arcpy
import os
from arcpy import env
from arcTUFLOW_Library import config_set

#_______________________________________________________________________________
# user specified from arc
### inputs
##1 - TUFLOW Folder Path
##2 - TUFLOW executable path

# read inputs
tuflow_folder = arcpy.GetParameterAsText(0)
tfexe = arcpy.GetParameterAsText(1)
proj = arcpy.GetParameterAsText(2)
clean_proj = proj.replace("'", '"') # this is required as the string is read in with singlequotes, but if it is written to .prj with single quotes, Arc doesn't recognise it! 


# display inputs
arcpy.AddMessage('TUFLOW Folder: '+tuflow_folder)
arcpy.AddMessage('TUFLOW Executable = '+tfexe)
arcpy.AddMessage('Projection = '+clean_proj)

#_______________________________________________________________________________
# get mxd from arc
mxd = arcpy.mp.MapDocument("CURRENT")
mxdpath = mxd.filePath
if len(mxdpath) < 3:
	arcpy.AddWarning("Map Document not saved, please save before configuring model")

arcpy.AddMessage('Map document = '+mxdpath)
config_file = mxdpath[0:len(mxdpath)-4]+'_config.txt'
arcpy.AddMessage('Configuration File = '+config_file)
if os.path.isfile(str(config_file)):
	arcpy.AddMessage('Configuration File '+config_file+' already exists... overwriting')
	os.remove(config_file)

message = config_set(config_file,tuflow_folder,tfexe,clean_proj)
if message is not None:
	arcpy.AddError('Error occured writing configuration file.')
	arcpy.AddMessage('Message: '+message)
