import os
from arcTUFLOW_Library import run_tuflow

# inputs from Arc
basepath = arcpy.GetParameterAsText(0)
projection = arcpy.GetParameterAsText(1)
tfexe = arcpy.GetParameterAsText(2)


# Folders below ignore top level (e.g. model, as these are create when the subfolders are)
TUFLOW_Folders = ["\\bc_dbase","\\check", "\\model\gis\\empty", "\\results", "\\runs\\log"]

for x in TUFLOW_Folders:
    tmppath = basepath+"\\TUFLOW"+x
    print tmppath
    if os.path.isdir(tmppath):
        arcpy.AddMessage("Directory Already Exists: "+tmppath)
    else:
        arcpy.AddMessage("Creating Directory: "+tmppath)
        os.makedirs(tmppath)

        
# Write Projection.prj Create a file ('w' for write, creates if doesnt exit)
arcpy.AddMessage("Writing projection to to \\model\\gis\\projection.prj")
f = file(basepath+"\\TUFLOW\\model\\gis\\Projection.prj", 'w')
clean_proj = projection.replace("'", '"')
arcpy.AddMessage(projection)
arcpy.AddMessage(clean_proj)
f.write(clean_proj)
f.flush()
f.close()

# Write .tcf file
arcpy.AddMessage("Writing TUFLOW control file.")
tcf = basepath+r'\TUFLOW\runs\Create_Empties.tcf'
f = file(tcf, 'w')
f.write("GIS FORMAT == SHP\n")
f.write("SHP Projection == ..\model\gis\projection.prj\n")
f.write("Write Empty GIS Files == ..\model\gis\empty\n")
f.flush()
f.close()

# Call TUFLOW
arcpy.AddMessage("Running TUFLOW.")

message = run_tuflow(tfexe,tcf)
if message <> None:
	arcpy.AddMessage(message)
else:
	arcpy.AddMessage("Done.")
