'''
Load Simulation Files from TLF File

version 1.0

author: Wood Rodgers, Inc.
	http://www.woodrodgers.com

'''
import arcview # Options: arcview, arceditor, arcinfo
import arcpy
import os, string, sys, time, math, traceback, fileinput, linecache
import csv, re

yyyy = time.strftime("%Y", time.localtime())
mm = time.strftime("%m", time.localtime())
dd = time.strftime("%d", time.localtime())

map_doc = "CURRENT"
in_tuflow = sys.argv[1]
lyrPath = r"J:\Gis\DataSources\Org_Private\WoodRodgers\Scripts\arcTUFLOW\ToolData\LayerFiles"

tuflow_GroupLayer = r"J:\Gis\DataSources\Org_Private\WoodRodgers\Scripts\arcTUFLOW\ToolData\LayerFiles\TUFLOW_(EmptyGroup).lyr"

def main():
    #set up mxd
    arcpy.env.workspace = os.path.dirname(map_doc)
    mxd = arcpy.mp.MapDocument(map_doc)
    df = arcpy.mp.ListDataFrames(mxd, "Layers")[0]
    groupLayer = arcpy.mp.Layer(tuflow_GroupLayer)
    arcpy.mp.AddLayer(df, groupLayer,"BOTTOM")
    targetGroupLayer = arcpy.mp.ListLayers(mxd, "TUFLOW", df)[0]
    layer_list = []
    #get list of shapefile to add to mxd
    infile = open(in_tuflow, "r")
    for l in infile.readlines():
        if l.startswith("Opening GIS Layer:"):
            shp = l.split("Opening GIS Layer:")[1].strip()
            if arcpy.Exists(shp):
                if shp not in layer_list:
                    layer_list.append(shp)
            else:
                arcpy.AddMessage( "File not found:" + shp)
        if l.startswith("Reading .tcf File"):
            tcf_path = l.split("..")[1].strip()
            tcf_dir = os.path.dirname(tcf_path)
        if l.startswith("tgc>> Read GIS"):
            rpath = l.split("==")[1].strip()
            if rpath.find("|") > 0:
                for r in rpath.split("|"):
                    ipath = r.strip()
                    fpath = os.path.join(tcf_dir, ipath)
                    if arcpy.Exists(fpath):
                        if fpath not in layer_list:
                            layer_list.append(fpath)
                    else:
                        arcpy.AddMessage( "File not found:" + fpath)
            else:
                fpath = os.path.join(tcf_dir,rpath)
                if arcpy.Exists(fpath):
                    if fpath not in layer_list:
                        layer_list.append(fpath)
                else:
                    arcpy.AddMessage( "File not found:" + fpath)

    for layer in layer_list:
        addLayer = arcpy.mp.Layer(layer)
        arcpy.mp.AddLayerToGroup(df, targetGroupLayer, addLayer, "BOTTOM")
    #apply symbology to layers in mxd
    lf_list = os.listdir(lyrPath)
    for lyr in arcpy.mp.ListLayers(mxd, "TUFLOW", df):
        if lyr.isGroupLayer:
            for slyr in lyr:
                lyrFile =  "_{0}_{1}_empty_{2}.lyr".format(str(slyr).split("_")[0],str(slyr).split("_")[1], str(slyr).split("_")[-1])
                if lyrFile in lf_list:
                    updateLayer = arcpy.mp.ListLayers(mxd, slyr.datasetName, df)[0]
                    sourceLayer = arcpy.mp.Layer(os.path.join(lyrPath, lyrFile))
                    arcpy.mp.UpdateLayer(df, updateLayer, sourceLayer, True)

if __name__ == '__main__':
    main()
